//+------------------------------------------------------------------+
//|                                                Better Volume.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 clrGreen          
#property indicator_color2 clrLightGray
#property indicator_color3 clrLightGray
#property indicator_color4 clrLightGray
#property indicator_color5 clrCrimson      
#property indicator_color6 clrMagenta      
#property indicator_color7 clrBlack    
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2

extern int     NumberOfBars=500; // 0 ; 500;
extern string  Note="0 means Display all bars";
extern int     MAPeriod = 100;
extern int     LookBack = 10;
extern int     width1 = 2;
extern int     width2 = 2;

double red[],blue[],yellow[],green[],white[],magenta[],v4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,red);
   SetIndexStyle(0,DRAW_HISTOGRAM,0,width2);
   SetIndexLabel(0,"Climax High ");

   SetIndexBuffer(1,blue);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,width2);
   SetIndexLabel(1,"Neutral");

   SetIndexBuffer(2,yellow);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,width2);
   SetIndexLabel(2,"Low ");

   SetIndexBuffer(3,green);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,width2);
   SetIndexLabel(3,"HighChurn ");

   SetIndexBuffer(4,white);
   SetIndexStyle(4,DRAW_HISTOGRAM,0,width2);
   SetIndexLabel(4,"Climax Low ");

   SetIndexBuffer(5,magenta);
   SetIndexStyle(5,DRAW_HISTOGRAM,0,width2);
   SetIndexLabel(5,"ClimaxChurn ");

   SetIndexBuffer(6,v4);
   SetIndexStyle(6,DRAW_LINE,0,2);
   SetIndexLabel(6,"Average("+(string)MAPeriod+")");

   IndicatorShortName("Better Volume");
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   double VolLowest,Range,Value2,Value3,HiValue2,HiValue3,LoValue3,tempv2,tempv3,tempv;
   if(NumberOfBars==0 || NumberOfBars>rates_total)
      NumberOfBars=rates_total;  //
//---
   int begin=(prev_calculated<1)?NumberOfBars-MAPeriod:rates_total-prev_calculated;
//---
   for(int i=begin;i>=0;i--)
     {
      red[i]= 0; blue[i] = (double)tick_volume[i]; yellow[i] = 0; green[i] = 0; white[i] = 0; magenta[i] = 0;
      Value2=0;Value3=0;HiValue2=0;HiValue3=0;LoValue3=99999999;tempv2=0;tempv3=0;tempv=0;

      VolLowest=(double)tick_volume[ArrayMinimum(tick_volume,20,i)];
      if(tick_volume[i]==VolLowest)
        {
         yellow[i]=(double)tick_volume[i];
         blue[i]=0;
        }
//---
      Range=(high[i]-low[i]);
      Value2=tick_volume[i]*Range;

      if(Range != 0 )
         Value3 = tick_volume[i]/Range;

      for(int n=i;n<i+MAPeriod;n++)
        {
         tempv=tick_volume[n]+tempv;
        }
      v4[i]=NormalizeDouble(tempv/MAPeriod,0);
//---
      for(int n=i;n<i+LookBack;n++)
        {
         tempv2=tick_volume[n]*((high[n]-low[n]));
         if( tempv2 >= HiValue2 )
            HiValue2 = tempv2;

         if(tick_volume[n]*((high[n]-low[n]))!=0)
           {
            tempv3=tick_volume[n]/((high[n]-low[n]));
            if(tempv3>HiValue3)
               HiValue3=tempv3;
            if(tempv3<LoValue3)
               LoValue3=tempv3;
           }
        }
//---
      if(Value2==HiValue2 && close[i]>(high[i]+low[i])/2)
        {
         red[i] = (double)tick_volume[i];
         blue[i]=0;
         yellow[i]=0;
        }
//---
      if(Value3==HiValue3)
        {
         green[i]= (double)tick_volume[i];
         blue[i] =0;
         yellow[i]=0;
         red[i]=0;
        }
      if(Value2==HiValue2 && Value3==HiValue3)
        {
         magenta[i]=(double)tick_volume[i];
         blue[i]=0;
         red[i]=0;
         green[i]=0;
         yellow[i]=0;
        }
      if(Value2==HiValue2 && close[i]<=(high[i]+low[i])/2)
        {
         white[i]=(double)tick_volume[i];
         magenta[i]=0;
         blue[i]=0;
         red[i]=0;
         green[i]=0;
         yellow[i]=0;
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
